{% extends "customers/base.html" %}
{% load i18n %}
{% load active_tag %}
{% load widget_tweaks %}
{% load staticfiles %}

{% block title %}Configuración del servicio {{ service.number }}{% endblock %}
{% block pagelevelcss %}
{% endblock %}

{% block page %}
{%if can_show_detail %}
  <!-- begin breadcrumb -->
  <ol class="breadcrumb float-xl-right">
    <li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
    <li class="breadcrumb-item"><a href="{% url 'customer-list' %}">Clientes</a></li>
    <li class="breadcrumb-item"><a href="{% url 'customer-detail' pk=customer.pk %}">{{ customer.rut }}</a></li>
    <li class="breadcrumb-item"><a href="{% url 'service-list' customer_pk=customer.pk %}">Servicios Contratados</a></li>
    <li class="breadcrumb-item"><a href="{% url 'service-detail' slug=service.pk %}">#{{ service.number }}</a></li>
    <li class="breadcrumb-item active">Configuración de servicio</li>
  </ol>
  <!-- end breadcrumb -->

  <!-- begin page-header -->
  <h1 class="page-header">#{{ service.number }} - {{ customer.name }}</h1>
  <!-- end page-header -->

  <ul class="nav nav-pills mb-2">
    <li class="nav-item {% add_active request 'service-detail' %}">
      <a href="{% url 'service-detail' slug=service.pk %}"class="nav-link">
        <span class="d-sm-none">General</span>
        <span class="d-sm-block d-none">General</span>
      </a>
    </li>
    <li class="nav-item {% add_active request 'service-network-detail' %}">
      <a href="{% url 'service-network-detail' slug=service.slug %}" class="nav-link">
        <span class="d-sm-none">Red</span>
        <span class="d-sm-block d-none">Red</span>
      </a>
    </li>
    <!--
    <li class="nav-item {% add_active request 'service-calls' %}">
      <a href="{% url 'service-calls' slug=service.slug %}" class="nav-link">
        <span class="d-sm-none">Registro de Llamadas</span>
        <span class="d-sm-block d-none">Registro de Llamadas</span>
      </a>
    </li>
    -->
    <li class="nav-item {% add_active request 'service-gallery' %}">
        <a href="{% url 'service-gallery' slug=service.slug %}" class="nav-link">
            <span class="d-sm-none">Galería</span>
            <span class="d-sm-block d-none">Galería</span>
        </a>
    </li>
    <li class="nav-item {% add_active request 'service-documents' %}">
      <a href="{% url 'service-documents' slug=service.slug %}" class="nav-link">
        <span class="d-sm-none">Documentos</span>
        <span class="d-sm-block d-none">Documentos</span>
      </a>
    </li>
    <li class="nav-item {% add_active request 'service-extras' %}">
      <a href="{% url 'service-extras' slug=service.slug %}" class="nav-link">
        <span class="d-sm-none">Prefacturación</span>
        <span class="d-sm-block d-none">Prefacturación</span>
      </a>
    </li>
    <li class="nav-item {% add_active request 'service-plan-orders' %}">
      <a href="{% url 'service-plan-orders' slug=service.slug %}" class="nav-link">
        <span class="d-sm-none">Orden de Servicio</span>
        <span class="d-sm-block d-none">Orden de Servicio</span>
      </a>
    </li>
    <li class="nav-item">
        <a href="#" class="nav-link active">
            <span class="d-sm-none">Configuración</span>
            <span class="d-sm-block d-none">Configuración</span>
        </a>
    </li>
    <li class="nav-item {% add_active request 'service-typify' %}">
			<a href="{% url 'service-typify' service.slug %}" class="nav-link">
				<span class="d-sm-none">Tipificaciones</span>
				<span class="d-sm-block d-none">Tipificaciones</span>
			</a>
		</li>
    <li class="nav-item {% add_active request 'service-billing' %}">
        <a href="{% url 'service-billing' service.slug %}" class="nav-link">
          <span class="d-sm-none">Estado de Cuenta servicio</span>
          <span class="d-sm-block d-none">Estado de Cuenta servicio</span>
        </a>
      </li>     
    <li class="nav-item {% add_active request 'invoice-list' %}">
      <a href="{% url 'invoice-list' service.customer.pk %}" class="nav-link">
        <span class="d-sm-none">Estado de Cuenta cliente</span>
        <span class="d-sm-block d-none">Estado de Cuenta cliente</span>
      </a>
    </li>     
  </ul>

<!-- begin row -->
<div class="row">
    <!-- begin col-12 -->
    <div class="col-xl-12 ui-sortable">
      <!-- begin panel -->
      <div class="panel panel-inverse" data-sortable-id="ui-general-1">
        <!-- begin panel-heading -->
        <div class="panel-heading ui-sortable-handle">
          <h4 class="panel-title">Configuración de servicio</h4>
          <div class="panel-heading-btn">
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
          </div>
        </div>
        <!-- end panel-heading -->
        <!-- begin panel-body -->
        <div class="panel-body">
          {% csrf_token %}
            {% if checked_3month == 'Si' %}
              <label class="custom-control custom-switch">
                <input type="checkbox" class="custom-control-input"  id=email_3month onclick="getJson()" checked>
                <label class="custom-control-label" for="email_3month"> Bloquear onboarding email</label>
              </label>
            {% endif %}
            {% if checked_3month == 'No' %}
              <label class="custom-control custom-switch">
                <input type="checkbox" class="custom-control-input"  id=email_3month onclick="getJson()">
                <label class="custom-control-label" for="email_3month"> Bloquear onboarding email</label>
              </label>
            {% endif %}

            {% if checked_post_activacion_email == 'Si' %}
              <label class="custom-control custom-switch">
                <input type="checkbox" class="custom-control-input" id=email_post_activacion onclick="getJson()" checked>
                <label class="custom-control-label" for="email_post_activacion"> Bloquear envío de correo post activación</label>
              </label><br>
            {% endif %}
            {% if checked_post_activacion_email == 'No' %}
            <label class="custom-control custom-switch">
              <input type="checkbox" class="custom-control-input" id=email_post_activacion onclick="getJson()">
              <label class="custom-control-label" for="email_post_activacion"> Bloquear envío de correo post activación</label>
            </label><br>
            {% endif %}
            <pre id="json-display"></pre>
            <button id="send_nuevo_cliente_email" class="btn btn-success" onclick="showModal()">Enviar Post Instalación</button>
            <button id="send_onboarding_manual" class="btn btn-success" onclick="showModal2()">Enviar Onboarding</button>
            {% if request.user.is_superuser %}
              <button id="save" class="btn btn-success">Guardar cambios</button>
            {% endif %}

            <div class="modal fade" id="confirmationModal" tabindex="-1" role="dialog" aria-labelledby="confirmationModalLabel" aria-hidden="true">
              <div class="modal-dialog" role="document">
                <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="confirmationModalLabel">Revisar</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  Confirmación envío de correo Post Instalación
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" onclick="send_email()" data-dismiss="modal">Enviar</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
                </div>
                </div>
              </div>
            </div>
            <div class="modal fade" id="confirmationModal2" tabindex="-1" role="dialog" aria-labelledby="confirmationModalLabel2" aria-hidden="true">
              <div class="modal-dialog" role="document">
                <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="confirmationModalLabel2">Revisar</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  Confirmación envío de correo Onboarding
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" onclick="send_email2()" data-dismiss="modal">Enviar</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
                </div>
                </div>
              </div>
            </div>
        </div>
        <!-- end panel-body -->
      </div>
    </div>
  </div>
  {%else%}
  <!-- begin page-header -->
  <h1 class="page-header">  Servicio </h1>
  <!-- end page-header -->
<div class="alert alert-success"  style="background-color: rgb(245, 156, 26); text-align: center;" role="alert">
  <h4 class="alert-heading" style=" text-align: center;">No encontrado</h4>
  <hr>
  <h5 class="mb-0">Cambie de operador o vuelva al listado.</h5>
</div>
{% endif %}
{% endblock %}
{% block pageleveljs %}

<script type="text/javascript" src="{% static 'theme/build/js/pages/jquery.json-editor.min.js' %}"></script>
<script>

    function showModal()
    {
      $('#confirmationModal').modal('show');
    }

    function showModal2()
    {
      $('#confirmationModal2').modal('show');
    }

    function send_email2()
    {
      var csrftoken = $("[name=csrfmiddlewaretoken]").val();
            $.ajaxSetup({
                beforeSend: function(xhr, settings) {
                  xhr.setRequestHeader("X-CSRFToken", csrftoken);
                }
            });
      const serviceId = window.location.pathname.split('/services/')[1].split('/configuration/')[0];
      var send_data = {"service_id": serviceId};
      
      var url = '{% url "send-onboarding-email" %}';
      x = $.ajax({
            type: 'POST',
            url: url,
            data: send_data,
            success: function(datos)
            {
              alert(datos.message);
            }
        })
      
    }

    function send_email()
    {
      var csrftoken = $("[name=csrfmiddlewaretoken]").val();
            $.ajaxSetup({
                beforeSend: function(xhr, settings) {
                  xhr.setRequestHeader("X-CSRFToken", csrftoken);
                }
            });
      const serviceId = window.location.pathname.split('/services/')[1].split('/configuration/')[0];
      var send_data = {"service_number": serviceId};
      
      var url = '{% url "manual-post-instalacion" %}';
      x = $.ajax({
            type: 'POST',
            url: url,
            data: send_data,
            success: function(datos)
            {
              alert(datos.message);
            }
        })
      
    }

    function getJson() {
        try {
            var csrftoken = $("[name=csrfmiddlewaretoken]").val();
            $.ajaxSetup({
                beforeSend: function(xhr, settings) {
                  xhr.setRequestHeader("X-CSRFToken", csrftoken);
                }
            });

            //aqui obtengo json inicial del backend
            var check_3month = document.getElementById("email_3month").checked;
            var post_activacion_email = document.getElementById("email_post_activacion").checked;


            const serviceId = window.location.pathname.split('/services/')[1].split('/configuration/')[0];
            $.get(`/services/${serviceId}/configuration/ajax/`+'?'+'month3='+check_3month+'&postActivacion='+post_activacion_email, function(res) {
                let json = null;
                if (res && res.data) {
                    json = res.data;
                }
                var editor = new JsonEditor('#json-display', json ? json : {});
                $('#save').on('click', function () {
                    const newJson = $('#json-display')[0].innerText
                    try{
                      var objeto = JSON.parse(newJson);
                    } catch(e) {
                      alert(e);
                    }
                    var url = '{% url "update-service-configuration" %}';
                    var send_data = {"nuevoJson": newJson,
                                     "number": serviceId};
                    console.log(send_data);
                    $.ajax({
                      type: 'POST',
                      url: url,
                      data: send_data,
                      success: function(datos)
                      {
                        alert("Se han guardado los cambios exitosamente.");
                        location.reload();
                      }
                    })
                    //aqui hago peticion de guardar en el backend enviando newJson
                });
            })
            /*const jsontest = JSON.stringify({
                  "id": 1001,
                  "type": "donut",
                  "name": "Cake",
                  "description": "http://en.wikipedia.org/wiki/Doughnut",
                  "price": 2.55,
                  "available": {
                    "store": 42,
                    "warehouse": 600
                  },
                  "topping": [
                    { "id": 5001, "type": "None" },
                    { "id": 5002, "type": "Glazed" },
                    { "id": 5005, "type": "Sugar" },
                    { "id": 5003, "type": "Chocolate" },
                    { "id": 5004, "type": "Maple" }
                  ]
                })
                
            return JSON.parse(json);*/
        } catch (ex) {
            alert('Formato de JSON incorrecto: ' + ex);
            var errorJson = document.getElementById("errorJson");
            errorJson.innerHTML = "Formato de JSON incorrecto: " + ex;
        }
    }
    getJson()
</script>
{% endblock %}